<template>
  <div>
    <div class="edit-container" v-if="open">
      <div class="edit-top">
        <div class="left-top">
          <img src="@/assets/images/back.png" @click="cancel()" />
          <div class="left-title"></div>
        </div>
        <div class="center-top">
        </div>
        <div class="right-top">
          <el-button @click="cancel()">{{ $t('form.cancel') }}</el-button>
          <el-button type="primary" @click="showApprove">{{ $t('page.business.study.studyFormApply.shenyue')
          }}</el-button>
        </div>
      </div>
      <div class="edit-content">
        <div class="content-left">
          <TemplateTable ref="templateTable" :sn="form.templateSn" :templateData="form" fillType="review" />
          <div class="content-title">
            <div class="line"></div>
            <div class="subtitle"> {{ $t('page.business.study.studyFormApply.qmxx') }}</div>
          </div>
          <div class="pal">
            <el-table :data="qmxxList" v-loading="loadingQmxx">
              <el-table-column :label="$t('page.business.study.studyFormApply.qmr')" align="center" prop="qmrMc"
                width="150px" />
              <el-table-column :label="$t('page.business.study.studyFormApply.qmyy')" align="center" prop="qmyy"
                width="150px" />
              <el-table-column :label="$t('page.business.study.studyFormApply.qmsj')" align="center" prop="createTime"
                width="150px" />
              <el-table-column :label="$t('page.business.study.studyFormApply.bzyy')" align="center" prop="remark"
                :show-overflow-tooltip="true" />
            </el-table>
          </div>
          <div class="pal">
            <pagination v-show="totalQmxx > 0" :total="totalQmxx" :page.sync="queryParamsQmxx.pageNum"
              :limit.sync="queryParamsQmxx.pageSize" @pagination="getQmxxList" />
          </div>
        </div>
        <div class="content-right">
          <div class="content-title">
            <div class="line"></div>
            <div class="subtitle"> {{ $t('page.business.study.studyFormApply.jcgj') }}</div>
          </div>
          <JcgjList ref="jcgjList" @handleQuery="getJjcgjList" :showXg="true" />

          <pagination v-show="jcgjTotal > 0" small layout="prev, pager, next" :total="jcgjTotal"
            @pagination="getJjcgjList" />
        </div>
      </div>
    </div>
    <el-dialog :title="$t('page.business.study.studyFormApply.shenyue')" :visible.sync="openApprove" width="500px"
      append-to-body :close-on-click-modal="false">
      <el-form ref="formApprove" :model="formApprove" :rules="rulesApprove" label-width="120px" v-if="openApprove">
        <div class="sbzdtcma"> <input type="text"> <input type="password"> </div>
        <el-row>
          <el-col :span="24">
            <el-form-item :label="$t('form.qmyy')" prop="qmyy">
              <el-input type="text" :value="formApprove.qmyy" maxlength="50" disabled
                :placeholder="$t('form.placeholderInput')" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item :label="$t('form.remark')" prop="remark">
              <el-input type="textarea" v-model="formApprove.remark" :rows="5" maxlength="500"
                :placeholder="$t('form.placeholderInput')">
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item :label="$t('form.signer')">
              <el-input type="text" v-model="nickName" maxlength="50" disabled
                :placeholder="$t('form.placeholderInput')" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item :label="$t('form.password')" prop="qmrmm">
              <el-input type="password" v-model="formApprove.qmrmm" maxlength="20"
                :placeholder="$t('form.placeholderInput')" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="approve">{{ $t('form.confirm') }}</el-button>
        <el-button @click="openApprove = false">{{ $t('form.cancel') }}</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { studyFormApply_sy, studyFormApply_info, studyFormApply_jcgj, studyFormApply_qmxx } from "@/api/business/study/studyFormApply"
import { mapGetters } from 'vuex'
import JcgjList from "@/views/business/comps/common/JcgjList";
import TemplateTable from '@/views/business/comps/template/TemplateTable';

export default {
  name: "Sy",
  components: { TemplateTable, JcgjList },
  data() {
    return {
      form: {},
      qmxxList: [],
      totalQmxx: 0,
      open: true,
      loadingQmxx: true,
      queryParamsQmxx: {
        formId: null,
        pageNum: 1,
        pageSize: 10
      },
      jcgjList: [],
      jcgjTotal: 0,
      queryParamsJcgj: {
        pageNum: 1,
        formId: null,
        pageSize: 10,
      },
      openApprove: false,
      formApprove: {},
      rulesApprove: {
        qmrmm: [{
          required: true,
          message: ' ',
          trigger: 'blur'
        }]
      }
    }
  },
  computed: {
    ...mapGetters([
      'nickName', 'name'
    ]),
  },
  created() {
  },
  methods: {
    getJjcgjList(val) {
      this.$modal.loading()
      studyFormApply_jcgj(_.merge({}, this.queryParamsJcgj, val)).then(response => {
        this.jcgjList = response.rows
        this.jcgjTotal = response.total
        this.$refs.jcgjList.init(this.jcgjList)
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    getQmxxList() {
      this.loadingQmxx = true
      studyFormApply_qmxx(this.queryParamsQmxx).then(response => {
        this.qmxxList = response.rows
        this.totalQmxx = response.total
        this.loadingQmxx = false
      })
    },
    cancel() {
      this.$emit('close')
      this.open = false
    },
    reset() {
      this.form = {}
      this.resetForm("form")
    },
    show(row) {
      this.reset()
      this.$modal.loading()
      this.queryParamsJcgj.formId = row.id
      this.queryParamsQmxx.formId = row.id
      studyFormApply_info({ id: row.id }).then(response => {
        this.form = response.data
        this.getQmxxList()
        this.getJjcgjList()
        this.open = true
      }).finally(() => {
        this.$modal.closeLoading()
      })
    },
    async showApprove() {
      let content = await this.$refs.templateTable.getFormData()
      if (content) {
        this.openApprove = true
        this.resetApprove()
        this.formApprove.bdnr = JSON.stringify(content)
        this.formApprove.id = this.form.id
      }
    },
    resetApprove() {
      this.formApprove = {
        id: null,
        qmyy: this.$t('page.business.study.studyFormApply.ysy'),
        remark: '',
        bdnr: '',
        qmrmm: '',
      }
      this.resetForm("formApprove")
    },
    approve() {
      this.$refs["formApprove"].validate(valid => {
        if (valid) {
          this.$modal.loading()
          studyFormApply_sy(this.formApprove).then(response => {
            this.openApprove = false
            this.$emit('close')
            this.open = false
          }).finally(() => {
            this.$modal.closeLoading()
          })
        }
      })
    }
  }
}
</script>
